<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/language.oop5.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'es',
  ),
  'this' => 
  array (
    0 => 'language.oop5.autoload.php',
    1 => 'Autocarga de clases',
  ),
  'up' => 
  array (
    0 => 'language.oop5.php',
    1 => 'Clases y objetos',
  ),
  'prev' => 
  array (
    0 => 'language.oop5.constants.php',
    1 => 'Constantes de clases',
  ),
  'next' => 
  array (
    0 => 'language.oop5.decon.php',
    1 => 'Constructores y destructores',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'es',
    'path' => 'language/oop5/autoload.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.oop5.autoload" class="sect1">
 <h2 class="title">Autocarga de clases</h2>
 <p class="para">
  Muchos desarrolladores que escriben aplicaciones orientadas a objetos
  crean un fichero fuente de PHP para cada definición de clase. Una de las
  mayores molestias es tener que hacer una larga lista de inclusiones
  al comienzo de cada script (uno por cada clase).
 </p>
 <p class="para">
  En PHP 5 esto ya no es necesario. La
  función <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> registra cualquier número de
  autocargadores, posibilitando que las clases e interfaces sean cargadas automáticamente
  si no están definidas actualmente. Al registrar autocargadores, a PHP se le da
  una última oportunidad de cargar las clases o interfaces antes de que falle por un error.
 </p>
 <div class="tip"><strong class="tip">Sugerencia</strong>
  <p class="para">
   Aunque la función <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> también puede ser empleada para
   autocargar clases e interfaces, es preferible utilizar la
   función <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span>. Esto es debido a que es
   una alternativa más flexible (posibilitando que se pueda especificar cualquier número
   de autocargadores en la aplicación, tales como los de las bibliotecas de terceros). Por esta
   razón, se desaconseja el uso de <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> y es obsoleto
   a partir de PHP 7.2.0.
  </p>
 </div>
 <blockquote class="note"><p><strong class="note">Nota</strong>: 
  <p class="para">
   Antes de 5.3.0, las excepciones lanzadas en la función
   <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> no podían ser capturadas en el
   bloque <a href="language.exceptions.php" class="link">catch</a>, resultando en
   un error fatal. Desde 5.3 en adelante, esto es posible simpre que, si
   se lanza una excepción personalizada, esté disponible la clase de la excepción personalizada.
   La función <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> podría utilizarse recursivamente para
   cargar la clase de excepción personalizada.
  </p>
 </p></blockquote>
 <blockquote class="note"><p><strong class="note">Nota</strong>: 
  <p class="para">
   La autocarga no está disponible si se utiliza PHP en el
   <a href="features.commandline.php" class="link">modo interactivo</a> CLI.
  </p>
 </p></blockquote>
 <blockquote class="note"><p><strong class="note">Nota</strong>: 
  <p class="para">
   Si el nombre de la clase se utiliza, por ejemplo, en <span class="function"><a href="function.call-user-func.php" class="function">call_user_func()</a></span>,
   este puede contener algunos caracteres peligrosos tales como <code class="literal">../</code>.
   Se recomienda no utilizar la entrada del usuario en tales funciones, o al menos
   verificar dicha entrada en <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span>.
  </p>
 </p></blockquote>
 <p class="para">
  <div class="example" id="example-235">
   <p><strong>Ejemplo #1 Ejemplo de autocarga</strong></p>
   <div class="example-contents"><p>
    Este ejemplo intenta cargar las clases <code class="literal">MiClase1</code>
    y <code class="literal">MiClase2</code> desde los ficheros <var class="filename">MiClase1.php</var>
    y <var class="filename">MiClase2.php</var>, respectivamente.
   </p></div>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$nombre_clase</span><span style="color: #007700">) {<br />    include </span><span style="color: #0000BB">$nombre_clase </span><span style="color: #007700">. </span><span style="color: #DD0000">'.php'</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$obj  </span><span style="color: #007700">= new </span><span style="color: #0000BB">MiClase1</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">$obj2 </span><span style="color: #007700">= new </span><span style="color: #0000BB">MiClase2</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

  </div>
  <div class="example" id="example-236">
   <p><strong>Ejemplo #2 Otro ejemplo de autocarga</strong></p>
   <div class="example-contents"><p>
    Este ejemplo intenta cargar la interfaz <code class="literal">IPrueba</code>.
   </p></div>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$nombre</span><span style="color: #007700">) {<br />    </span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$nombre</span><span style="color: #007700">);<br />});<br /><br />class </span><span style="color: #0000BB">Foo </span><span style="color: #007700">implements </span><span style="color: #0000BB">IPrueba </span><span style="color: #007700">{<br />}<br /><br /></span><span style="color: #FF8000">/*<br />string(7) "IPrueba"<br /><br />Fatal error: Interface 'IPrueba' not found in ...<br />*/<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

  </div>
  <div class="example" id="example-237">
   <p><strong>Ejemplo #3 Autocarga con manejo de excepciones para 5.3.0+</strong></p>
   <div class="example-contents"><p>
    Este ejemplo lanza una excepción y demuestra los bloques try/catch.
   </p></div>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$nombre</span><span style="color: #007700">) {<br />    echo </span><span style="color: #DD0000">"Intentando cargar </span><span style="color: #0000BB">$nombre</span><span style="color: #DD0000">.\n"</span><span style="color: #007700">;<br />    throw new </span><span style="color: #0000BB">Exception</span><span style="color: #007700">(</span><span style="color: #DD0000">"Imposible cargar </span><span style="color: #0000BB">$nombre</span><span style="color: #DD0000">."</span><span style="color: #007700">);<br />});<br /><br />try {<br />    </span><span style="color: #0000BB">$obj </span><span style="color: #007700">= new </span><span style="color: #0000BB">ClaseNoCargable</span><span style="color: #007700">();<br />} catch (</span><span style="color: #0000BB">Exception $e</span><span style="color: #007700">) {<br />    echo </span><span style="color: #0000BB">$e</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">getMessage</span><span style="color: #007700">(), </span><span style="color: #DD0000">"\n"</span><span style="color: #007700">;<br />}<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>El resultado del ejemplo sería:</p></div>
   <div class="example-contents screen">
<div class="cdata"><pre>
Intentando cargar ClaseNoCargable.
Imposible cargar ClaseNoCargable.
</pre></div>
   </div>
  </div>
  <div class="example" id="example-238">
   <p><strong>Ejemplo #4 Autocarga con manejo de excepciones para 5.3.0+: Excepción personalizada ausente</strong></p>
   <div class="example-contents"><p>
    Este ejemplo lanza una excepción para una excepción personalizada no cargable.
   </p></div>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$nombre</span><span style="color: #007700">) {<br />    echo </span><span style="color: #DD0000">"Intentando cargar </span><span style="color: #0000BB">$nombre</span><span style="color: #DD0000">.\n"</span><span style="color: #007700">;<br />    throw new </span><span style="color: #0000BB">ExcepciónAusente</span><span style="color: #007700">(</span><span style="color: #DD0000">"Imposible cargar </span><span style="color: #0000BB">$nombre</span><span style="color: #DD0000">."</span><span style="color: #007700">);<br />});<br /><br />try {<br />    </span><span style="color: #0000BB">$obj </span><span style="color: #007700">= new </span><span style="color: #0000BB">ClaseNoCargable</span><span style="color: #007700">();<br />} catch (</span><span style="color: #0000BB">Exception $e</span><span style="color: #007700">) {<br />    echo </span><span style="color: #0000BB">$e</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">getMessage</span><span style="color: #007700">(), </span><span style="color: #DD0000">"\n"</span><span style="color: #007700">;<br />}<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>El resultado del ejemplo sería:</p></div>
   <div class="example-contents screen">
<div class="cdata"><pre>
Intentando cargar ClaseNoCargable.
Intentando cargar ExcepciónAusente.

Fatal error: Class &#039;ExcepciónAusente&#039; not found in testExcepcionAusente.php on line 4
</pre></div>
   </div>
  </div>
 </p>
 
  <div class="simplesect">
   <h3 class="title">Ver también</h3>
   <p class="para">
    <ul class="simplelist">
     <li><span class="function"><a href="function.unserialize.php" class="function">unserialize()</a></span></li>
     <li><a href="var.configuration.php#ini.unserialize-callback-func" class="link">unserialize_callback_func</a></li>
     <li><a href="var.configuration.php#ini.unserialize-max-depth" class="link">unserialize_max_depth</a></li>
     <li><span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span></li>
     <li><span class="function"><a href="function.spl-autoload.php" class="function">spl_autoload()</a></span></li>
     <li><span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span></li>
    </ul>
   </p>
  </div>
 
</div><?php manual_footer($setup); ?>